
#ifndef __DMAPI_JFS_H__
#define __DMAPI_JFS_H__

typedef struct {
        __u32 val[2];                   /* file system id type */
} jfs_fsid_t;

#ifndef MAXFIDSZ
#define MAXFIDSZ        46
typedef struct fid {
        __u16		fid_len;                /* length of data in bytes */
        unsigned char   fid_data[MAXFIDSZ];     /* data (variable length)  */
} fid_t;
#endif

typedef struct jfs_fid {
        __u16	fid_len;        /* length of remainder */
        __u16	fid_pad;        /* padding, must be zero */
        __u32	fid_gen;        /* generation number, dm_igen_t */
        __u64	fid_ino;        /* inode number, dm_ino_t */
} jfs_fid_t;

typedef struct jfs_handle {
        union {
                __s64		align;      /* force alignment of ha_fid     */
                jfs_fsid_t	_ha_fsid;   /* unique file system identifier */
        } ha_u;
        jfs_fid_t		ha_fid;     /* file system specific file ID  */
} jfs_handle_t;
#define ha_fsid ha_u._ha_fsid

#define JFS_NAME "jfs"

#define JFS_HSIZE(handle)       (((char *) &(handle).ha_fid.fid_pad  \
			       	 - (char *) &(handle))               \
		                 + (handle).ha_fid.fid_len)
	
#define JFS_HANDLE_CMP(h1, h2) memcmp(h1, h2, sizeof(jfs_handle_t))

#define FSHSIZE         sizeof(fsid_t)
#endif	
